/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

//
// Created by webpigeon on 22/06/22.
//

#ifndef FGGL_ECS_TYPES_HPP
#define FGGL_ECS_TYPES_HPP

#include <cstdint>

namespace fggl::ecs {

	struct entity {
		const std::uint32_t id;
	};
	constexpr const entity NULL_ENTITY = {0};
	constexpr const entity MAX_ENTITY = {0xFFFFFFFF};

	struct componentID {
		const std::uint32_t id;
	};
	constexpr const entity NULL_COMPONENT = {0};

}

#endif //FGGL_ECS_TYPES_HPP
