/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef FGGL_ECS_UTILITY_HPP
#define FGGL_ECS_UTILITY_HPP

#include <cstdint>

namespace fggl::ecs {

	using IDType = std::uint32_t;
	using entity_t = IDType;
	using component_type_t = IDType;

	constexpr IDType NULL_ENTITY = 0;

	template<class T>
	class TypeIdGenerator {
		private:
			static IDType m_count;
		public:
			template<class U>
			static const IDType GetNewID() {
				static const IDType idCounter = m_count++;
				return idCounter;
			}
	};

	template<class T> IDType TypeIdGenerator<T>::m_count = 1;
}

#endif
