/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef FGGL_GFX_CAMERA_HPP
#define FGGL_GFX_CAMERA_HPP

#include <fggl/math/types.hpp>

namespace fggl::gfx {

	struct Camera {
		constexpr const static char name[] = "Camera";
		math::vec3 target = math::vec3(0.0f, 0.0f, 0.0f);
		float aspectRatio = 1280.0f / 720.0f;
		float fov = glm::radians(45.0f);
		float nearPlane = 0.1f;
		float farPlane = 100.0f;
	};

};

#endif
