/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef FGGL_INPUT_H
#define FGGL_INPUT_H

#include <memory>
#include <fggl/input/keyboard.hpp>
#include <fggl/input/mouse.hpp>
#include <fggl/input/gamepad.hpp>

namespace fggl::input {

	class Input {
		public:
			Input() = default;
			void frame(float dt);

			KeyboardInput keyboard;
			MouseInput mouse;
			GamepadInput gamepads;
	};

}

#endif
